<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Gestionar Flujos</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>¡Comencemos!</strong>
      </div>
      <div class="supSec">
        ¿Deseas gestionar, editar o crear un Flujo?
      </div>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <v-sheet class="overflow-y-auto CardScroll">
        <v-row>
          <v-col
            v-for="(flujo, indexFlujo) in flujos"
            :key="indexFlujo"
            :xs="12"
            :sm="12"
            :md="6"
            :lg="3"
          >
            <v-card class="generalCard pa-4">
              <div>
                <v-btn
                  x-small
                  class="float-left"
                  text
                  icon
                  @click="(dialogDelete = true), (flujo_delete = flujo)"
                >
                  <v-img
                    max-width="30"
                    src="@/assets/img/delete.svg"
                    class="white--text align-end"
                  ></v-img>
                </v-btn>
                <v-btn :to="flujo.to" x-small class="float-right" text icon>
                  <v-img
                    max-width="30"
                    src="@/assets/img/icoEditar.svg"
                    class="white--text align-end"
                  ></v-img>
                </v-btn>
              </div>
              <v-card-text>
                <div class="cardFranqName cardFranqNameLine">
                  {{ flujo.descripcion }}
                </div>
                <div class="cardCreacion">
                  <div>
                    Fecha de creación:
                    {{ moment(flujo.fecha_creacion).format("DD/MM/YYYY") }}
                  </div>
                </div>
                <v-footer absolute class="CardCustomAction">
                  <v-col>
                    <v-btn
                      :to="flujo.to_modulos"
                      class="ma-2"
                      dark
                      tile
                      depressed
                      color="primary"
                      >Gestionar Modulos</v-btn
                    >
                  </v-col>
                </v-footer>
              </v-card-text>
            </v-card>
          </v-col>
        </v-row>
      </v-sheet>
      <v-divider />
      <v-row>
        <v-col :key="cardAddFlujo.title" :xs="12" :sm="12" :md="6" :lg="3">
          <v-card
            :to="cardAddFlujo.to"
            :color="cardAddFlujo.color"
            class="generalCard pa-4"
          >
            <div
              class="cardTitle cardFranqNameWhiteLine text-center white--text pb-2 pa-0"
              v-text="cardAddFlujo.title"
            ></div>
            <v-avatar size="60" class="pa-2" tile>
              <v-img
                :contain="true"
                :aspect-ratio="1"
                position="center"
                :src="cardAddFlujo.src"
                :lazy-src="cardAddFlujo.src"
                class="white--text align-end"
              >
                <template v-slot:placeholder>
                  <v-row
                    class="fill-height ma-0"
                    align="center"
                    justify="center"
                  >
                    <v-progress-circular
                      indeterminate
                      color="grey lighten-5"
                    ></v-progress-circular>
                  </v-row>
                </template>
              </v-img>
            </v-avatar>
          </v-card>
        </v-col>
        <v-col :key="cardComponente.title" :xs="12" :sm="12" :md="6" :lg="3">
          <v-card
            :to="cardComponente.to"
            :color="cardComponente.color"
            class="generalCard pa-4"
          >
            <div
              class="cardTitle cardFranqNameWhiteLine text-center white--text pb-2 pa-0"
              v-text="cardComponente.title"
            ></div>
            <v-avatar size="60" class="pa-2" tile>
              <v-img
                :contain="true"
                :aspect-ratio="1"
                position="center"
                :src="cardComponente.src"
                :lazy-src="cardComponente.src"
                class="white--text align-end"
              >
                <template v-slot:placeholder>
                  <v-row
                    class="fill-height ma-0"
                    align="center"
                    justify="center"
                  >
                    <v-progress-circular
                      indeterminate
                      color="grey lighten-5"
                    ></v-progress-circular>
                  </v-row>
                </template>
              </v-img>
            </v-avatar>
          </v-card>
        </v-col>
      </v-row>
      <template>
        <v-dialog v-model="dialogDelete" persistent max-width="600px">
          <v-card>
            <v-card-title>
              <div class="titModal">
                <strong>¿Seguro que deseas eliminar este flujo?</strong>
              </div>
            </v-card-title>
            <v-card-text></v-card-text>
            <v-card-actions>
              <v-row justify="center" style="margin-right:0px">
                <v-btn
                  class="ma-2"
                  dark
                  tile
                  depressed
                  color="secondary"
                  @click="dialogDelete = false"
                  >No, cancelar</v-btn
                >
                <v-btn
                  class="ma-2"
                  depressed
                  dark
                  tile
                  color="primary"
                  :class="[{ desac: deletingFlujo }]"
                  @click="deleteFlujo()"
                  >Si, continuar</v-btn
                >
              </v-row>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </template>
    </div>
  </div>
</template>
<script>
import axios from "axios";
import store from "@/store";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
import moment from "moment";
export default {
  name: "Component-Flujos",
  data() {
    return {
      moment: moment,
      flujo_delete: null,
      dialogDelete: false,
      modulos_flujos: null,
      deletingFlujo: false,
      cardAddFlujo: {
        title: "Crear Flujo",
        src: require("@/assets/img/masBlanco.svg"),
        description: "Añade una nuevo flujo a la lista.",
        to: {
          name: "privilegios_flujos_nuevo",
        },
        color: "#494949",
      },
      cardComponente: {
        title: "Gestionar Componentes",
        src: require("@/assets/img/masBlanco.svg"),
        description: "Añade un nuevo componente a la lista.",
        to: {
          name: "privilegios_flujos_componentes",
        },
        color: "#494949",
      },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Privilegios",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios",
          },
        },
        {
          text: "Flujos",
          disabled: true,
        },
      ],
      flujos: [],
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
  },
  methods: {
    getFlujos() {
      var self = this;
      axios
        .get("/flujo/secure/get/")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setFlujos(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setFlujos(data) {
      if (data) {
        data.forEach((itemFlujo) => {
          itemFlujo.to_modulos = {
            name: "privilegios_flujos_modulos",
            params: {
              flujo: this.serviceCommons.objectToBase64(itemFlujo),
            },
          };
          itemFlujo.to = {
            name: "privilegios_flujos_edicion",
            params: {
              flujo: this.serviceCommons.objectToBase64(itemFlujo),
            },
          };
        });
        this.flujos = data;
      }
    },
    deleteFlujo() {
      var self = this;
      self.flujo_delete.id_empleado_modifica = user.empleado;
      axios
        .delete("/flujo/secure/delete", { data: self.flujo_delete })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              self.dialogDelete = false;
              self.getFlujos();
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.deletingFlujo = false;
        });
    },
  },
  created() {
    this.getFlujos();
  },
};
</script>
